<?php
if (!class_exists('RedsysAPI')) include_once 'RedsysAPI.php';

function decrypt_3DES($message, $key)
{
    // Se establece un IV por defecto
    $bytes = array(0, 0, 0, 0, 0, 0, 0, 0); //byte [] IV = {0, 0, 0, 0, 0, 0, 0, 0}
    $iv = implode(array_map("chr", $bytes)); //PHP 4 >= 4.0.2

    // Se cifra
    $ciphertext = mcrypt_decrypt(MCRYPT_3DES, $key, $message, MCRYPT_MODE_CBC, $iv); //PHP 4 >= 4.0.2
    return $ciphertext;
}

function ObtenerClaveEncriptacion($hash, $ds_merchant_order)
{
    $miObj = new RedsysAPI;
    $kcEncriptado = $miObj->base64_url_decode($hash);
    $clave = substr($ds_merchant_order, 0, 5);
    $kc = decrypt_3DES($kcEncriptado, $clave);
    return $kc;
}

$esJsonp = false;
$error = true;
$msgError = "";
$msgOut = "";

try {

    //Comprobamos si es una peticion jsonP
    if (isset($_GET['callback'])) {
        $esJsonp = true;
        $data = array('DS_MERCHANT_AMOUNT' => $_GET['DS_MERCHANT_AMOUNT']
        , 'DS_MERCHANT_ORDER' => $_GET['DS_MERCHANT_ORDER']
        , 'DS_MERCHANT_MERCHANTCODE' => $_GET['DS_MERCHANT_MERCHANTCODE']
        , 'DS_MERCHANT_CURRENCY' => $_GET['DS_MERCHANT_CURRENCY']
        , 'DS_MERCHANT_TRANSACTIONTYPE' => $_GET['DS_MERCHANT_TRANSACTIONTYPE']
        , 'DS_MERCHANT_TERMINAL' => $_GET['DS_MERCHANT_TERMINAL']
        , 'DS_MERCHANT_MERCHANTURL' => $_GET['DS_MERCHANT_MERCHANTURL']
        , 'DS_MERCHANT_URLOK' => $_GET['DS_MERCHANT_URLOK']
        , 'DS_MERCHANT_URLKO' => $_GET['DS_MERCHANT_URLKO']
        , 'HASH' => $_GET['HASH']
        );
    } else {
        $data = json_decode(file_get_contents('php://input'), true);
    }

    if ($data != null) {
        $ds_merchant_amount = "";
        $ds_merchant_order = "";
        $ds_merchant_merchantcode = "";
        $ds_merchant_currency = "";
        $ds_merchant_transactiontype = "";
        $ds_merchant_terminal = "";
        $ds_merchant_merchanturl = "";
        $ds_merchant_urlok = "";
        $ds_merchant_urlko = "";
        $ds_merchant_merchantData = "";
        $hashKc = "";


        if (isset($data['DS_MERCHANT_AMOUNT']))
            $ds_merchant_amount = $data["DS_MERCHANT_AMOUNT"];
        else
            $msgError = "ds_merchant_amount - ";

        if (isset($data['DS_MERCHANT_ORDER']))
            $ds_merchant_order = $data["DS_MERCHANT_ORDER"];
        else
            $msgError = $msgError . "ds_merchant_order - ";

        if (isset($data['DS_MERCHANT_MERCHANTCODE']))
            $ds_merchant_merchantcode = $data["DS_MERCHANT_MERCHANTCODE"];
        else
            $msgError = $msgError . "ds_merchant_merchantcode - ";

        if (isset($data['DS_MERCHANT_CURRENCY']))
            $ds_merchant_currency = $data["DS_MERCHANT_CURRENCY"];
        else
            $msgError = $msgError . "ds_merchant_currency - ";

        if (isset($data['DS_MERCHANT_TRANSACTIONTYPE']))
            $ds_merchant_transactiontype = $data["DS_MERCHANT_TRANSACTIONTYPE"];
        else
            $msgError = $msgError . "ds_merchant_transactiontype - ";

        if (isset($data['DS_MERCHANT_TERMINAL']))
            $ds_merchant_terminal = $data["DS_MERCHANT_TERMINAL"];
        else
            $msgError = $msgError . "ds_merchant_terminal - ";

        if (isset($data['DS_MERCHANT_MERCHANTURL']))
            $ds_merchant_merchanturl = $data["DS_MERCHANT_MERCHANTURL"];
        else
            $msgError = $msgError . "ds_merchant_merchanturl - ";

        if (isset($data['DS_MERCHANT_URLOK']))
            $ds_merchant_urlok = $data["DS_MERCHANT_URLOK"];
        else
            $msgError = $msgError . "ds_merchant_urlok - ";

        if (isset($data['DS_MERCHANT_URLKO']))
            $ds_merchant_urlko = $data["DS_MERCHANT_URLKO"];
        else
            $msgError = $msgError . "ds_merchant_urlko - ";

        if (isset($data['HASH']))
            $hashKc = $data["HASH"];
        else
            $msgError = $msgError . "HASH - ";

        if (isset($data['DS_MERCHANT_MERCHANTDATA']))
            $ds_merchant_merchantData = $data["DS_MERCHANT_MERCHANTDATA"];


        //Comprobamos que esté OK
        if (!isset($ds_merchant_amount) || $ds_merchant_amount == "" ||
            !isset($ds_merchant_order) || $ds_merchant_order == "" ||
            !isset($ds_merchant_merchantcode) || $ds_merchant_merchantcode == "" ||
            !isset($ds_merchant_currency) || $ds_merchant_currency == "" ||
            !isset($ds_merchant_transactiontype) || $ds_merchant_transactiontype == "" ||
            !isset($ds_merchant_terminal) || $ds_merchant_terminal == "" ||
            !isset($hashKc) || $hashKc == "") {

            $msgError = "Error obteniedo la firma" . $msgError;
        } else {

            $redsysApi = new RedsysAPI;
            // Se Rellenan los campos
            $redsysApi->setParameter("DS_MERCHANT_AMOUNT", $ds_merchant_amount);
            $redsysApi->setParameter("DS_MERCHANT_ORDER", strval($ds_merchant_order));
            $redsysApi->setParameter("DS_MERCHANT_MERCHANTCODE", $ds_merchant_merchantcode);
            $redsysApi->setParameter("DS_MERCHANT_CURRENCY", $ds_merchant_currency);
            $redsysApi->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $ds_merchant_transactiontype);
            $redsysApi->setParameter("DS_MERCHANT_TERMINAL", $ds_merchant_terminal);
            $redsysApi->setParameter("DS_MERCHANT_MERCHANTURL", $ds_merchant_merchanturl);
            $redsysApi->setParameter("DS_MERCHANT_URLOK", $ds_merchant_urlok);
            $redsysApi->setParameter("DS_MERCHANT_URLKO", $ds_merchant_urlko);


            if (isset($ds_merchant_mame) && $ds_merchant_mame !== "") {
                $redsysApi->setParameter("DS_MERCHANT_MERCHANTNAME", $ds_merchant_mame);
            }

            if (isset($ds_merchant_consumer_languaje) && $ds_merchant_consumer_languaje !== "") {
                $redsysApi->setParameter("DS_MERCHANT_CONSUMERLANGUAGE", $ds_merchant_consumer_languaje);
            }

            if (isset($ds_merchant_merchantData) && $ds_merchant_merchantData !== "") {
                $redsysApi->setParameter("DS_MERCHANT_MERCHANTDATA", $ds_merchant_merchantData);
            }

            if (isset($ds_merchant_identifier) && $ds_merchant_identifier !== "") {
                $redsysApi->setParameter("DS_MERCHANT_IDENTIFIER", $ds_merchant_identifier);
            }

            //Datos de configuración
            $kc = ObtenerClaveEncriptacion($hashKc, $ds_merchant_order);
            $params = $redsysApi->createMerchantParameters();
            $signature = $redsysApi->createMerchantSignature($kc);
            $arr = array('Ds_MerchantParameters' => $params, 'Ds_Signature' => $signature);
            $msgOut = json_encode($arr, JSON_FORCE_OBJECT);
            $error = false;
        }
    } else {
        $msgError = "No se han recibido datos";
    }

} catch (Exception $ex) {
    $msgError = $ex->getMessage();
}

if ($error == true) {
    $arr = array('Error' => $msgError);
    $msgOut = json_encode($arr, JSON_FORCE_OBJECT);
}

if ($esJsonp) {
    header_remove();
    header("content-type: text/javascript");
    echo $_GET['callback'] . '(' . $msgOut . ');';
} else {
    header_remove();
    header('Content-Type: application/json');
    echo $msgOut;
}


?>