<?php

if (!class_exists('RedsysAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'RedsysAPI.php');
if (!class_exists('TpvVirtualAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'TpvVirtualAPI.php');
chdir('../../../../');
require('includes/application_top.php');

$urlAJAX = tep_href_link('../TpvVirtual/ObtenerFirma.php', '', 'SSL');
$devolucionActiva = false;
$botonesConfirmacion = "";
$clave_encriptacion = "";
$merchant_order = "";
$importe_cobrado = 0;
$importe_devuelto = 0;
$tipoTransaccionRealizar = 0;
$order_status_id = null;


function EncriptarClaveEncriptacion($kc, $ds_merchant_order)
{
    $miObj = new RedsysAPI;
    //Encriptamos la clave de encriptacion y la pasamos a Base64;
    $clave = substr($ds_merchant_order, 0, 5);
    $kcEncriptado = $miObj->encrypt_3DES($kc, $clave);
    return $miObj->base64_url_encode($kcEncriptado);

}


function obtenerDatosOperacionTpvVirtual($order_id)
{

    $tpvVirtuaOperaciones = array();

    if ($order_id > 0) {
        $consulta = "SELECT so.merchant_order, 
                            so.merchant_code, 
                            so.importe_cobrado, 
                            so.importe_devuelto, 
                            so.id_terminal, 
                            so.moneda, 
                            so.clave_encriptacion, 
                            so.tipo_pago, 
                            so.id_estado, 
                            seo.id_estado_ecommerce
            FROM NCP_TPV_VIRTUAL_OPERACIONES so
            JOIN NCP_TPV_VIRTUAL_ESTADO_OPERACION seo ON seo.id_estado = so.id_estado
            WHERE id_order = " . $order_id . " ORDER BY id_order  ";


        $query = tep_db_query($consulta);
        $tpvVirtuaOperaciones = tep_db_fetch_array($query);
    }

    return $tpvVirtuaOperaciones;
}

function generarFormulario($datosOperacion)
{

    global $devolucionActiva, $botonesConfirmacion, $clave_encriptacion, $importe_cobrado, $importe_devuelto, $tipoTransaccionRealizar, $order_status_id;
    $formularioTPV = null;


    if ($datosOperacion != null && count($datosOperacion) > 0) {

        $merchant_order = $datosOperacion['merchant_order'];
        $merchant_code = $datosOperacion['merchant_code'];
        $importe_cobrado = $datosOperacion['importe_cobrado'];
        $importe_devuelto = $datosOperacion['importe_devuelto'];
        $terminal = $datosOperacion['id_terminal'];
        $moneda = $datosOperacion['moneda'];
        $tipoPago = $datosOperacion['tipo_pago'];
        $id_estado = $datosOperacion['id_estado'];
        $clave_encriptacion = $datosOperacion['clave_encriptacion'];
        $order_status_id = $datosOperacion['id_estado_ecommerce'];
        $nomComercio = MODULE_PAYMENT_TPV_VIRTUAL_NOMBRE_COMERCIO;

        $urlPost = "";


        if (strcmp(MODULE_PAYMENT_TPV_VIRTUAL_ENTORNO, 'Test') == 0)
            $urlPost = MODULE_PAYMENT_TPV_VIRTUAL_URL_PRUEBAS;
        else
            $urlPost = MODULE_PAYMENT_TPV_VIRTUAL_URL;


        $idiomaConfigurado = MODULE_PAYMENT_TPV_VIRTUAL_IDIOMA;
        if (strcmp(MODULE_PAYMENT_TPV_VIRTUAL_IDIOMA, '-- Auto --') == 0)
            $idioma_tpv = 0;
        else {
            $arrayIdiomas = TpvVirtualAPI::idiomas('es');
            $idioma_tpv = $arrayIdiomas[$idiomaConfigurado];
        }


        $urlRespuestaTPV = "";
        $urlOk = tep_href_link('ext/modules/payment/tpvbbva/tpv_virtual_ok.php', '', 'SSL');
        $urlKO = tep_href_link('ext/modules/payment/tpvbbva/tpv_virtual_ko.php', '', 'SSL');


        $importeSinDecimales = $importe_cobrado * 100;
        $tipoTransaccionRealizar = -1;

        $redsysAPI = new RedsysAPI;
        $redsysAPI->setParameter("DS_MERCHANT_AMOUNT", $importeSinDecimales);
        $redsysAPI->setParameter("DS_MERCHANT_ORDER", $merchant_order);
        $redsysAPI->setParameter("DS_MERCHANT_MERCHANTCODE", $merchant_code);
        $redsysAPI->setParameter("DS_MERCHANT_CURRENCY", $moneda);
        $redsysAPI->setParameter("DS_MERCHANT_TERMINAL", $terminal);
        $redsysAPI->setParameter("DS_MERCHANT_MERCHANTURL", $urlRespuestaTPV);
        $redsysAPI->setParameter("DS_MERCHANT_URLOK", $urlOk);
        $redsysAPI->setParameter("DS_MERCHANT_URLKO", $urlKO);

        //Dependiendo del tipo de pago podemos realizar unas u otras operaciones.
        switch ($tipoPago) {
            case TpvVirtualAPI::PAGO_ESTANDAR:
                if (TpvVirtualAPI::PAGO_ACEPTADO == (int)$id_estado || TpvVirtualAPI::DEVOLUCION_PARCIAL == (int)$id_estado) {
                    //Si la orden tramitada ha sido como tipo 0 es una orden normal y se puede devolver. 3
                    $tipoTransaccionRealizar = TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL;
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, '', $moneda, trim($merchant_order), $merchant_code, $terminal, $tipoTransaccionRealizar, '', $nomComercio, $urlRespuestaTPV, '', $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpDevolucionForm', '', '', '','');
                    $devolucionActiva = true;
                }
                break;
            case TpvVirtualAPI::PREAUTORIZACION:
                if (TpvVirtualAPI::PAGO_PREAUTORIZADO == (int)$id_estado) {
                    //Si la orden está tramitada como una preautorizacion admitimos 2 operaciones diferentes
                    $tipoTransaccionRealizar = TpvVirtualAPI::CONFIRMACION_PREAUTORIZACION;
                    $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $tipoTransaccionRealizar);
                    $DsMerchantParameters = $redsysAPI->createMerchantParameters();
                    $DsSignature = $redsysAPI->createMerchantSignature($clave_encriptacion);
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, $importeSinDecimales, $moneda, $merchant_order, $merchant_code, $terminal, $tipoTransaccionRealizar, null, $nomComercio, $urlRespuestaTPV, null, $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpConfirmacionPreautorizacion', null, $DsMerchantParameters, $DsSignature,'');

                    $tipoTransaccionRealizar = TpvVirtualAPI::ANULACION_PREAUTORIZACION;
                    $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $tipoTransaccionRealizar);
                    $DsMerchantParameters2 = $redsysAPI->createMerchantParameters();
                    $DsSignature2 = $redsysAPI->createMerchantSignature($clave_encriptacion);
                    $formularioTPV .= TpvVirtualAPI::obtenerFormularioTPV($urlPost, $importeSinDecimales, $moneda, $merchant_order, $merchant_code, $terminal, $tipoTransaccionRealizar, null, $nomComercio, $urlRespuestaTPV, null, $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpAnulacionPreautorizacion', null, $DsMerchantParameters2, $DsSignature2,'');

                    $botonesConfirmacion = '<input class="button" name="ConfirmarBtn" value="' . BS_CONFIRMAR_PREAUTORIZACION . '" type="button" onClick="confirmarPreautorizacion()"/> ';
                    $botonesConfirmacion .= '<input class="button" name="CancelarBtn"  value="' . BS_CANCELAR_PREAUTORIZACION . '" type="button" onClick="anulacionPreautorizacion()"/> ';
                } else if (TpvVirtualAPI::PREAUTORIZACION_CONFIRMADA == (int)$id_estado || TpvVirtualAPI::DEVOLUCION_PARCIAL == (int)$id_estado) {
                    //Si la preautorización ha sido confirmada tambien se puede anular
                    $tipoTransaccionRealizar = TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL;
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, '', $moneda, trim($merchant_order), $merchant_code, $terminal, $tipoTransaccionRealizar, '', $nomComercio, $urlRespuestaTPV, '', $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpDevolucionForm', '', '', '','');
                    $devolucionActiva = true;
                }

                break;
            case TpvVirtualAPI::PREAUTORIZACION_DIFERIDA:
                if (TpvVirtualAPI::PAGO_PREAUTORIZADO == (int)$id_estado) {
                    //Si la orden está tramitada como una preautorizacion diferida admitimos 2 operaciones diferentes
                    $tipoTransaccionRealizar = TpvVirtualAPI::CONFIRMACION_PREAUTORIZACION_DIFERIDA;
                    $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $tipoTransaccionRealizar);
                    $DsMerchantParameters = $redsysAPI->createMerchantParameters();
                    $DsSignature = $redsysAPI->createMerchantSignature($clave_encriptacion);
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, $importeSinDecimales, $moneda, $merchant_order, $merchant_code, $terminal, $tipoTransaccionRealizar, null, $nomComercio, $urlRespuestaTPV, null, $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpConfirmacionPreautorizacion', null, $DsMerchantParameters, $DsSignature,'');

                    $tipoTransaccionRealizar = TpvVirtualAPI::ANULACION_PREAUTORIZACION_DIFERIDA;
                    $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $tipoTransaccionRealizar);
                    $DsMerchantParameters2 = $redsysAPI->createMerchantParameters();
                    $DsSignature2 = $redsysAPI->createMerchantSignature($clave_encriptacion);
                    $formularioTPV .= TpvVirtualAPI::obtenerFormularioTPV($urlPost, $importeSinDecimales, $moneda, $merchant_order, $merchant_code, $terminal, $tipoTransaccionRealizar, null, $nomComercio, $urlRespuestaTPV, null, $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpAnulacionPreautorizacion', null, $DsMerchantParameters2, $DsSignature2,'');

                    $botonesConfirmacion = '<input class="button" name="ConfirmarBtn"  value="' . BS_CONFIRMAR_PREAUTORIZACION_DIFERIDA . '" type="button" onClick="confirmarPreautorizacion()"/> ';
                    $botonesConfirmacion .= '<input class="button" name="CancelarBtn"  value="' . BS_CANCELAR_PREAUTORIZACION_DIFERIDA . '" type="button"  onClick="anulacionPreautorizacion()"/> ';
                } else if (TpvVirtualAPI::PREAUTORIZACION_CONFIRMADA == (int)$id_estado || TpvVirtualAPI::DEVOLUCION_PARCIAL == (int)$id_estado) {
                    //Si la preautorización ha sido confirmada tambien se puede anular
                    $tipoTransaccionRealizar = TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL;
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, '', $moneda, trim($merchant_order), $merchant_code, $terminal, $tipoTransaccionRealizar, '', $nomComercio, $urlRespuestaTPV, '', $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpDevolucionForm', '', '', '','');
                    $devolucionActiva = true;
                }
                break;
            case TpvVirtualAPI::AUTENTICACION:
                if (TpvVirtualAPI::AUTENTICACION_REALIZADA == (int)$id_estado) {
                    //Si no han pasado 45 días se puede realizar una confirmación de autenticación.
                    $tipoTransaccionRealizar = TpvVirtualAPI::CONFIRMACION_AUTENTICACION;
                    $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $tipoTransaccionRealizar);
                    $DsMerchantParameters = $redsysAPI->createMerchantParameters();
                    $DsSignature = $redsysAPI->createMerchantSignature($clave_encriptacion);

                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, $importeSinDecimales, $moneda, $merchant_order, $merchant_code, $terminal, $tipoTransaccionRealizar, null, $nomComercio, $urlRespuestaTPV, null, $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpConfirmacionForm', null, $DsMerchantParameters, $DsSignature,'');
                    $botonesConfirmacion = '<input class="button" name="ConfirmacionAuth"  value="' . BS_CONFIRMAR_AUTENTICACION . '" type="button" onClick="confirmarAutenticacion()"/> ';
                } else if (TpvVirtualAPI::AUTENTICACION_CONFIRMADA == (int)$id_estado || TpvVirtualAPI::DEVOLUCION_PARCIAL == (int)$id_estado) {
                    //Si la Autenticacion ha sido confirmada tambien se puede anular
                    $tipoTransaccionRealizar = TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL;
                    $formularioTPV = TpvVirtualAPI::obtenerFormularioTPV($urlPost, '', $moneda, trim($merchant_order), $merchant_code, $terminal, $tipoTransaccionRealizar, '', $nomComercio, $urlRespuestaTPV, '', $urlOk, $urlKO, $idioma_tpv, 'TpvVirtualNcpDevolucionForm', '', '', '','');


                    $devolucionActiva = true;
                }
                break;
        }
    }

    return $formularioTPV;
}

$action = (isset($HTTP_GET_VARS['action']) ? $HTTP_GET_VARS['action'] : '');
$order_id = null;

if (isset($HTTP_GET_VARS['oID'])) {
    $order_id = tep_db_prepare_input($HTTP_GET_VARS['oID']);
    $orders_query = tep_db_query("select orders_id from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
    $orders = tep_db_fetch_array($orders_query);
    if (count($orders) <= 0)
        $messageStack->add(sprintf(ERROR_ORDER_DOES_NOT_EXIST, $order_id), 'error');
} else {

    $messageStack->add(sprintf(ERROR_ORDER_DOES_NOT_EXIST, $order_id), 'error');
}

include(DIR_WS_CLASSES . 'order.php');
require(DIR_WS_INCLUDES . 'template_top.php');
$order = new order($order_id);

$orders_statuses = array();
$orders_status_array = array();
$orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . (int)$languages_id . "' AND orders_status_id=" . $order->info['orders_status']);
$orders_status = tep_db_fetch_array($orders_status_query);
?>
<script type="text/javascript">

    function ClearForm() {

        //eliminamos el resto de nodos y enviamos el formulario
        document.getElementById("Ds_Merchant_Amount").remove();
        document.getElementById("Ds_Merchant_Order").remove();
        document.getElementById("Ds_Merchant_MerchantCode").remove();
        document.getElementById("Ds_Merchant_Currency").remove();
        document.getElementById("Ds_Merchant_TransactionType").remove();
        document.getElementById("Ds_Merchant_Terminal").remove();
        document.getElementById("Ds_Merchant_MerchantURL").remove();
        document.getElementById("Ds_Merchant_UrlOK").remove();
        document.getElementById("Ds_Merchant_UrlKO").remove();
        document.getElementById("Ds_Merchant_Titular").remove();
        document.getElementById("Ds_Merchant_MerchantName").remove();
        document.getElementById("Ds_Merchant_ProductDescription").remove();
        document.getElementById("Ds_Merchant_ConsumerLanguage").remove();
        document.getElementById("Ds_Merchant_MerchantData").remove();
        document.getElementById("Ds_Merchant_Identifier").remove();
    }


    function ObtenerFirma(hashFirma) {

        var ds_merchant_amount = document.getElementById("Ds_Merchant_Amount").value;
        var ds_merchant_order = document.getElementById("Ds_Merchant_Order").value;
        var ds_merchant_merchantcode = document.getElementById("Ds_Merchant_MerchantCode").value;
        var ds_merchant_currency = document.getElementById("Ds_Merchant_Currency").value;
        var ds_merchant_transactiontype = document.getElementById("Ds_Merchant_TransactionType").value;
        var ds_merchant_terminal = document.getElementById("Ds_Merchant_Terminal").value;
        var ds_merchant_merchanturl = document.getElementById("Ds_Merchant_MerchantURL").value;
        var ds_merchant_urlok = document.getElementById("Ds_Merchant_UrlOK").value;
        var ds_merchant_urlko = document.getElementById("Ds_Merchant_UrlKO").value;

        $.ajax({
            type: "GET",
            url: "<?=$urlAJAX?>",
            dataType: 'jsonp',
            jsonp: 'callback',
            crossDomain: true,
            data: {
                DS_MERCHANT_AMOUNT: ds_merchant_amount,
                DS_MERCHANT_ORDER: ds_merchant_order,
                DS_MERCHANT_MERCHANTCODE: ds_merchant_merchantcode,
                DS_MERCHANT_CURRENCY: ds_merchant_currency,
                DS_MERCHANT_TRANSACTIONTYPE: ds_merchant_transactiontype,
                DS_MERCHANT_TERMINAL: ds_merchant_terminal,
                DS_MERCHANT_MERCHANTURL: ds_merchant_merchanturl ? encodeURI(ds_merchant_merchanturl) : "",
                DS_MERCHANT_URLOK: ds_merchant_urlok ? encodeURI(ds_merchant_urlok) : "",
                DS_MERCHANT_URLKO: ds_merchant_urlko ? encodeURI(ds_merchant_urlko) : "",
                HASH: hashFirma
            },
            success: function (data) {
                if (data['Error']) {
                    alert(data['Error']);
                } else {
                    $('#Ds_Signature').val(data['Ds_Signature']);
                    $('#Ds_MerchantParameters').val(data['Ds_MerchantParameters']);
                    ClearForm();
                    document.forms["TpvVirtualNcpDevolucionForm"].submit();
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert("Se ha producido un error realizando la devolucion: " + textStatus);
            }
        });
    }


    function isNumeric(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    }

    function ValidaDevolucion(importe, importeDevuelto, hashFirma) {

        importeADevolver = document.getElementById("devolverInput").value;

        if (!isNumeric(importeADevolver)) {
            alert("<?= BS_IMPORTE_VALOR_NUMERICO ?>");
            return false;
        }

        if (importeADevolver <= 0) {
            alert("<?= BS_IMPORTE_MAYOR_0 ?>");
            return false;
        }

        if (importe == importeDevuelto) {
            alert("<?= BS_IMPORTE_MAYOR_COBRADO ?>");
            return false;
        }

        var importeAcomparar = parseFloat(importeDevuelto) + parseFloat(importeADevolver);
        if (importeAcomparar > importe) {
            alert("<?= BS_IMPORTE_MAYOR_COBRADO ?>");
            return false;
        }

        //El importe a devolver pasa sin transformar, asi que lo transformamos.

        var originalFloat = parseFloat(importeADevolver);
        var importeDevolverRedondeado = Math.round(originalFloat * 100) / 100;
        importeDevolverRedondeado = importeDevolverRedondeado.toFixed(2);

        var importeSinPuntos = importeDevolverRedondeado.toString().replace(".", "");
        importeSinPuntos = parseInt(importeSinPuntos.toString().replace(",", ""));
        var importeDevueltoFinal = parseInt(importeDevuelto) + parseInt(importeSinPuntos);

        var importeOriginalSinPuntos = importe.toString().replace(".", "");

        if (importeOriginalSinPuntos < importeDevueltoFinal) {
            alert("<?= BS_IMPORTE_MAYOR_COBRADO ?>");
            return false;
        }

        if (confirm("<?= BS_REEMBOLSAR_IMPORTE_INDICADO ?>")) {
            document.getElementById("Ds_Merchant_Amount").value = importeSinPuntos;
            ObtenerFirma(hashFirma);
        }
    }


    function confirmarPreautorizacion() {
        if (confirm("<?= BS_DESEA_CONFIRMAR_PREAUTORIZACION ?>")) {
            ClearForm();
            document.forms["TpvVirtualNcpConfirmacionPreautorizacion"].submit();
        }
    }

    function anulacionPreautorizacion() {
        if (confirm("<?= BS_DESEA_ANULAR_PREAUTORIZACION ?>")) {
            ClearForm();
            document.forms["TpvVirtualNcpAnulacionPreautorizacion"].submit();
        }
    }

    function confirmarAutenticacion() {
        if (confirm("<?= BS_DESEA_CONFIRMAR_PREAUTORIZACION ?>")) {
            ClearForm();
            document.forms["TpvVirtualNcpConfirmacionForm"].submit();
        }
    }


</script>


<table border="0" width="100%" cellspacing="0" cellpadding="2">
    <tr>
        <td width="100%">
            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                <tr>
                    <td class="pageHeading"><img src="../images/modules/payment/tpvbbva/logo.png" alt="BBVA">&nbsp;<?php echo HEADING_TITLE; ?></td>
                    <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
                    <td class="smallText" align="right">
                        <?= tep_draw_button(IMAGE_BACK, 'triangle-1-w', tep_href_link(TPV_VIRTUAL_FILENAME_ORDERS, 'oID=' . $HTTP_GET_VARS['oID'] . "&action=edit")) ?>

                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td>
            <table width="100%" border="0" cellspacing="0" cellpadding="2">
                <tr>
                    <td colspan="3"><?php echo tep_draw_separator(); ?></td>
                </tr>
                <tr>
                    <td valign="top">
                        <?php
                        $datosOperacion = obtenerDatosOperacionTpvVirtual($order_id);
                        $merchantOrder = $datosOperacion['merchant_order'];

                        if ($datosOperacion == null || $datosOperacion == "") {
                            echo '<center><span style="color:red">' . ERROR_ORDER_DOES_NOT_EXIST . '</span></center>';
                        } else {
                            $formulario = generarFormulario($datosOperacion);
                            echo $formulario;
                            ?>
                            <input type="hidden" name="id_estado_ecommerce" value="<?php echo $order_status_id; ?>" id="id_estado_ecommerce">

                            <table class="form">
                                <tr>
                                    <td><strong>Id</strong></td>
                                    <td><?= $merchantOrder ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?= BS_ESTADO_ORDEN ?></strong></td>
                                    <td><?= $orders_status['orders_status_name'] ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?= BS_IMPORTE_TOTAL ?></strong></td>
                                    <td><?= $importe_cobrado . '&nbsp;' . $order->info['currency']; ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?= BS_IMPORTE_DEVUELTO ?></strong></td>
                                    <td><?= $importe_devuelto . '&nbsp;' . $order->info['currency']; ?></td>
                                </tr>


                                <?php if ($devolucionActiva) { ?>
                                    <tr>
                                        <td><strong><span><?= BS_IMPORTE_A_DEVOLVER ?></span></strong></td>
                                        <td><input name="devolverInput" id="devolverInput" value="0"/></td>
                                    </tr>
                                    <tr>
                                        <td></td>
                                        <td>
                                            <button onClick="javascript:ValidaDevolucion('<?= $importe_cobrado ?>', '<?= $importe_devuelto ?>','<?= EncriptarClaveEncriptacion($clave_encriptacion, $datosOperacion['merchant_order']) ?>')"
                                                    class="scalable save" type="button"><span><?= BS_DEVOLVER_IMPORTE ?></span></button>
                                        </td>
                                    </tr>
                                    <?php
                                } else {
                                    if (strlen($botonesConfirmacion) > 0) {
                                        echo "<tr><td></td>";
                                        echo "<td>" . $botonesConfirmacion . "</td></tr>";
                                    }
                                }
                                ?>

                            </table>

                        <?php } ?>

                    </td>
                </tr>
                <tr>
                    <td><?php echo tep_draw_separator(); ?></td>
                </tr>
            </table>
        </td>
    </tr>
</table>
<?php
require(DIR_WS_INCLUDES . 'template_bottom.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
